package com.jcg.example.ehcache_no_xml;

import java.util.stream.IntStream;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;

import com.jcg.example.ehcache_no_xml.service.EhCacheExampleService;

/**
 * EhCache Example App with no XML Config
 *
 */
@SpringBootApplication
@EnableCaching
public class EhCacheNoXMLExample implements CommandLineRunner {
	
	@Autowired
	private EhCacheExampleService ehCacheExampleService;

	public static void main(String[] args) {
		System.out.println( "EhCache Example Running" );
        SpringApplication.run(EhCacheNoXMLExample.class, args);
        
	}

	@Override
	public void run(String... args) throws Exception {
		IntStream.range(0,5).forEach(i -> System.out.println(ehCacheExampleService.getCachedValue()));
		Thread.sleep(3000);
		IntStream.range(0,5).forEach(i -> System.out.println(ehCacheExampleService.getCachedValue()));
	}

}
